import { BehaviorSubject } from 'rxjs';
export declare function jsonParser(key: string, value: any): any;
export declare function extractParams(message: string, args?: number): string[];
export declare class Progress extends BehaviorSubject<Progress> {
    done: boolean;
    total: number;
    current: number;
    protected lastTime: number;
    constructor();
    setStart(total: number): void;
    setBatch(size: number): void;
    get progress(): number;
    next(progress: this): void;
    setDone(): void;
}
/**
 * Parses messages from websocket messages while handling batches and converting.
 */
export declare class Batcher {
    protected callback: (message: object) => void;
    protected batches: {
        [id: string]: {
            json: string;
            messageId: number;
            totalLength: number;
        };
    };
    protected progress: {
        [messageId: string]: Progress[];
    };
    constructor(callback: (message: object) => void);
    registerProgress(messageId: number, progress: Progress[]): void;
    handle(message: string): void;
    protected messageComplete(message: string): void;
}
